<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.25.2.19 $
 * $Author: tora60 $
 * $Date: 2010/08/27 00:46:55 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen('Access Denied');
    die();
}

$wysiwyg = 0;
include_once('spaw/spaw_control.class.php');

/* Sprachdatei auswaehlen */
mxGetLangfile(PMX_ADMIN_DIR . DS . 'language' . DS . 'blocks');

function BlocksAdmin()
{
    include('header.php');
    GraphicAdmin();
    title(_BLOCKSADMIN);

    ?>
<div id="block-tabs">

<ul class="tabs-nav">
  <li><a href="#block-list"><?php echo _BLOCKS_INSTALLEDLIST ?></a></li>
  <li><a href="#block-new-file"><?php echo _ADDNEWBLOCK . ' ' . _BLOCKFILE?></a></li>
  <li><a href="#block-new-html"><?php echo _ADDNEWBLOCK . ' (HTML)' ?></a></li>
  <li><a href="#block-new-rss"><?php echo _ADDNEWBLOCK . ' ' . _RSSCONTENT ?></a></li>
</ul>

<div id="block-list" class="tabs-panel">
<h3 class="block-hidecaption"><?php echo _BLOCKS_INSTALLEDLIST ?></h3>
<?php BlocksListAll() ?>
</div>

<div id="block-new-file" class="tabs-panel">
<h3><?php echo _ADDNEWBLOCK . ' ' . _BLOCKFILE?></h3>
<?php blockaddform('file') ?>
</div>

<div id="block-new-html" class="tabs-panel">
<h3><?php echo _ADDNEWBLOCK . ' (HTML)' ?></h3>
<?php blockaddform('html') ?>
</div>

<div id="block-new-rss" class="tabs-panel">
<h3><?php echo _ADDNEWBLOCK . ' ' . _RSSCONTENT ?></h3>
<?php blockaddform('rss') ?>
</div>

</div><!-- /block-tabs -->

<script type="text/javascript">
/* <![CDATA[ */
  $(document).ready(function(){
    $("#block-tabs").tabs();
    $("#block-tabs").tabs('select', 0);
    $("#block-tabs .block-hidecaption").hide();
  });
/* ]]> */
</script>

<?php
    /* Javascript & jquery for tabs */
    pmxHeader::add_tabs(false);

    include('footer.php');
}

function BlocksListAll()
{
    global $prefix;
    $img_activate = mxCreateImage('images/deactivate.gif', _ACTIVATE, array('title' => _ACTIVATE));
    $img_deactivate = mxCreateImage('images/activate.gif', _DEACTIVATE, array('title' => _DEACTIVATE));
    $img_delete = mxCreateImage('images/delete.gif', _DELETE, array('title' => _DELETE));
    $img_edit = mxCreateImage('images/edit.gif', _EDIT, array('title' => _EDIT));
    $img_view = mxCreateImage('images/view.gif', _SHOW, array('title' => _SHOW));
    $curpos = '';
    $class = '';
    $i = 0;

    if (isset($_GET['filter'])) {
        if ($_GET['filter'] == -1) {
            mxSessionDelVar('blockfilter');
        } else {
            mxSessionSetVar('blockfilter', $_GET['filter']);
        }
    }
    $filterlink[] = (mxSessionGetVar('blockfilter') == 1) ? '<b>' . _BLOCKSHOWACTIVE . '</b>' : '<a href="admin.php?op=BlocksAdmin&amp;filter=1">' . _BLOCKSHOWACTIVE . '</a>';
    $filterlink[] = (!mxSessionGetVar('blockfilter')) ? '<b>' . _ALL . '</b>' : '<a href="admin.php?op=BlocksAdmin&amp;filter=-1">' . _ALL . '</a>';
    $filterlink[] = (mxSessionGetVar('blockfilter') == 2) ? '<b>' . _BLOCKSHOWDEACTIVE . '</b>' : '<a href="admin.php?op=BlocksAdmin&amp;filter=2">' . _BLOCKSHOWDEACTIVE . '</a>';
    $filterlink = '[ ' . implode(' | ', $filterlink) . ' ]';

    switch (mxSessionGetVar('blockfilter')) {
        case 1:
            $qryfilter = ' WHERE active = 1 ';
            break;
        case 2:
            $qryfilter = ' WHERE active = 0 ';
            break;
        default:
            $qryfilter = '';
    }

    $qry = "SELECT bid, bkey, title, url, position, weight, active, blanguage, blockfile, view, refresh
            FROM ${prefix}_blocks " . $qryfilter . "
            ORDER BY position, weight";
    $result = sql_query($qry);
    while ($block = sql_fetch_array($result)) {
        $temp = $block['position'];
        if (mxIsNewsBlockfile($block['blockfile'])) {
            $temp = 'z';
        }

        $block['cachetime'] = getRefreshTimeString($block['refresh']);

        switch ($temp) {
            case 'c':
                $block['pos'] = _CENTERUP;
                break;
            case 'd':
                $block['pos'] = _CENTERDOWN;
                break;
            case 'r':
                $block['pos'] = _RIGHT;
                break;
            case 'z':
                $block['pos'] = _RIGHTNEWS;
                break;
            default:
                $block['pos'] = _LEFT;
        }

        switch (true) {
            case !empty($block['url']):
                $block['type'] = 'RSS/RDF';

                break;
            case !empty($block['blockfile']):
                $block['type'] = str_replace('.php', '', str_replace('block-', '', $block['blockfile'])) . ' (' . _BLOCKFILE2 . ')';

                break;
            default:
                $block['type'] = 'HTML';
        }

        switch ($block['view']) {
            case 1:
                $block['who_view'] = _MVGROUPS2;
                break;
            case 2:
                $block['who_view'] = _MVADMIN;
                break;
            case 3:
                $block['who_view'] = _MVANON;
                break;
            case 4:
                $block['who_view'] = _MVSYSADMIN;
                break;
            case 0:
            default:
                $block['who_view'] = _MVALL;
                break;
        }

        $block['title'] = (empty($block['active'])) ? '<i>' . $block['title'] . '</i>' : $block['title'];
        $block['change'] = (empty($block['active'])) ? $img_activate : $img_deactivate;
        $block['active'] = (empty($block['active'])) ? '<i>' . _INACTIVE . '</i>' : _ACTIVE;

        if ($GLOBALS['multilingual']) {
            if (empty($block['blanguage'])) {
                $block['blanguage'] = _ALL;
            } else {
                $block['blanguage'] = ucfirst($block['blanguage']);
            }
        }
        $allblocks[$temp][$i] = $block;
        $i++;
    }
    $newblocks = array();
    if (isset($allblocks)) {
        ksort($allblocks);
        foreach ($allblocks as $array) {
            $newblocks = array_merge($newblocks, $array);
        }
        unset($allblocks);
    }
    // $colspan = 8;
    $colspan = 7;
    $headline = '
    	<tr>
     		<th>' . _BLOCKORDER . '</th>
    		<th>' . _TITLE . '</th>
     		<th>' . _TYPE . '/' . _FILENAME . '</th>
     		<th>' . _STATUS . '</th>
     		<!-- <th>' . _CACHING . '</th> -->
     		<th>' . _VIEW . '</th>';
    if ($GLOBALS['multilingual']) {
        $headline .= '
        <th>' . _LANGUAGE . '</th>';
        $colspan++;
    }
    $headline .= '
    		<th>' . _FUNCTIONS . '</th>
    	</tr>';
    echo '<p class="align-center">' . $filterlink . '</p>';
    if (!count($newblocks)) {
        echo '<p class="align-center">' . _BLOCKNOBLOCKS . '</p>';
        return;
    }

    echo '
    <form action="admin.php" method="post">
    	<input type="hidden" name="op" value="BlocksListWeigth" />
      <table class="full list">';
    $i = 1;
    foreach ($newblocks as $block) {
        $class = ($class == '') ? ' class="alternate-a"' : '';
        extract($block);
        if ($curpos != $pos) {
            echo '
            	<tr>
            		<th colspan="' . $colspan . '">
            			<div class="bigger">' . _POSITION . ': <i>' . $pos . '</i></div>
            		</th>
            	</tr>
            	' . $headline . '
            	';
            $curpos = $pos;
            $i = 1;
        }
        echo '
        			<tr' . $class . '>
        				<td align="left">
        					<input type="text" name="weight[' . $bid . ']" value="' . $i . '" size="3" maxlength="3" />
        				</td>
        				<td>' . $title . '</td>
        				<td>' . $type . '</td>
        				<td>' . $active . '</td>
        				<!-- <td>' . $cachetime . '</td> -->
        				<td>' . $who_view . '</td>';
        if ($GLOBALS['multilingual']) {
            echo '
            		<td>' . $blanguage . '</td>';
        }
        echo '
        				<td nowrap="nowrap">
        					<font class="content">
        						<a href="admin.php?op=BlocksEdit&amp;bid=' . $bid . '">' . $img_edit . '</a>
        						<a href="admin.php?op=ChangeStatus&amp;bid=' . $bid . '">' . $change . '</a>';
        if ($pos != _RIGHTNEWS) {
            echo '
            				<a href="admin.php?op=BlocksDelete&amp;bid=' . $bid . '">' . $img_delete . '</a>
            				<a href="admin.php?op=block_show&amp;bid=' . $bid . '">' . $img_view . '</a>';
        }
        echo '
        					</font>
        				</td>
        			</tr>';
        $i++;
    }
    echo '
    					<tr>
    						<td colspan="' . $colspan . '">
    							<input type="submit" value="' . _BLOCKSAVEORDER . '" />
    						</td>
    					</tr>
    				</table>
    			</form>';

    echo '
    <p class="align-center">
        <a href="admin.php?op=fixweight" class="button">' . _FIXBLOCKS . '</a>
        <a href="admin.php?op=resetBlockCache" class="button">' . _BLOCKDELCACHE . '</a>
    </p>';
}

function BlocksListWeigth($pvs)
{
    global $prefix;
    $i = 0;
    foreach ($pvs['weight'] as $bid => $weight) {
        $qry = "UPDATE ${prefix}_blocks SET weight=" . $weight . " WHERE bid=" . $bid . " AND weight<>" . $weight;
        $result = sql_query($qry);
        if ($result) $i++;
    }
    if ($i) {
        repairweigth();
    }
    mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
}

function blockaddform ($mode)
{
    static $groupselect;
    if (!isset($groupselect)) {
        $groupselect = getGroupSelect(0);
    }

    switch ($mode) {
        case 'file':
            $type = _BLOCKFILE;
            break;
        case 'rss':
            $type = _RSSCONTENT;
            break;
        case 'html':
        default:
            $type = '(HTML)';
            break;
    }
    // OpenTable();
    // echo '<fieldset><legend>' . _ADDNEWBLOCK . ' ' . $type . '</legend>';
    echo '<form action="admin.php" method="post">';
    echo '<table class="full">';
    echo '<tr valign="top"><td width="20%">' . _TITLE . ':</td><td width="80%"><input type="text" name="title" size="30" maxlength="60" /></td></tr>';
    switch ($mode) {
        case 'file':
            echo '<tr valign="top"><td>' . _FILENAME . ':</td><td>' . mxGetBlockfileSelect('') . '</td></tr>';
            break;
        case 'rss':
            echo '<tr valign="top"><td>' . _RSSFILE . ':</td><td>' . getHeadlineSelect ('') . '</td></tr>';
            break;
        case 'html':
        default:
            if ($GLOBALS['wysiwyg']) {
                echo '<tr valign="top"><td colspan="2">' . _CONTENT . ':<br />';
                $sw = new SPAW_Wysiwyg('b_content', '', _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
                $sw->show();
            } else {
                echo '<tr valign="top"><td>' . _CONTENT . ':</td><td><textarea name="b_content" cols="60" rows="10"></textarea>';
            }

            echo '</td></tr>';
    }

    echo '<tr valign="top"><td>' . _POSITION . ':</td><td>' . getPositionSelect('l') . '</td></tr>';
    echo '<tr valign="top"><td>' . _WEIGHT . ':</td><td><input type="text" name="weight" size="3" maxlength="3" value="0" /></td></tr>';
    if ($GLOBALS['multilingual']) {
        echo '<tr valign="top"><td>' . _LANGUAGE . ':</td><td>' . mxLanguageSelect('blanguage', '', 'language', true) . '</td></tr>';
    } else {
        echo '<input type="hidden" name="blanguage" value="" />';
    }
    echo '<tr valign="top"><td>' . _ACTIVATE2 . '</td><td>' . getActiveSelect(1) . '</td></tr>';
    echo '<tr valign="top"><td>' . _VIEWPRIV . '</td><td>' . getViewSelect(0) . '</td></tr>';
    echo '<tr valign="top"><td><!-- ' . _VIEWPRIV . ' --></td><td>' . $groupselect . '</td></tr>';
    switch ($mode) {
        case 'rss':
            echo '<tr valign="top"><td>' . _REFRESHTIME . ':</td><td>' . getRefreshSelect(3600, 0) . '</td></tr>';
            break;
        case 'file':
            echo '<tr valign="top"><td>' . _CACHING . ':</td><td>' . getRefreshSelect(0, 1) . '</td></tr>';
            break;
    }

    echo '</table>';
    echo '<input type="hidden" name="op" value="BlocksAdd" />';
    echo '<input type="submit" value="' . _CREATEBLOCK . '" />';
    echo '</form><!--</fieldset>-->';
    // CloseTable();
}

function BlocksEdit()
{
    global $prefix;
    $bid = (int)$_GET['bid'];
    $menu = (empty($_GET['menu'])) ? 0 : 1;
    $result = sql_query("SELECT * FROM ${prefix}_blocks WHERE bid=" . $bid);
    $block = sql_fetch_array($result);
    extract($block);
    $type = (empty($url)) ? 'HTML' : _RSSCONTENT;
    $type = (empty($blockfile)) ? $type : _BLOCKFILE;
    $oldposition = $position;
    include('header.php');
    GraphicAdmin();
    title(_EDITBLOCK);
    OpenTable();
    echo '<fieldset><legend>' . _BLOCK . ': ' . $title . ' <em>' . $type . '</em></legend>'
     . '<form action="admin.php" method="post">'
     . '<table class="full">'
     . '<tr valign="top"><td width="20%">' . _TITLE . ':</td><td width="80%"><input type="text" name="title" size="30" maxlength="60" value="' . mxEntityQuotes($title) . '" /></td></tr>';
    switch ($type) {
        case _BLOCKFILE:
            if (mxIsNewsBlockfile($blockfile)) {
                echo '<input type="hidden" name="blockfile" value="' . $blockfile . '" />';
            } else {
                echo '<tr valign="top"><td>' . _FILENAME . ':</td><td>' . mxGetBlockfileSelect($blockfile) . '</td></tr>';
            }

            break;
        case _RSSCONTENT:
            echo '<tr valign="top"><td>' . _RSSFILE . ':</td><td>' . getHeadlineSelect($url) . '</td></tr>';

            break;
        default:
            echo '<tr valign="top"><td>' . _CONTENT . ':</td><td>';
            if ($GLOBALS['wysiwyg']) {
                $sw = new SPAW_Wysiwyg('b_content', $content, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
                $sw->show();
            } else {
                echo '<textarea name="b_content" cols="60" rows="10">' . $content . '</textarea>';
            }
            echo '</td></tr>';
    }

    if (!mxIsNewsBlockfile($blockfile)) {
        echo '<tr valign="top"><td>' . _POSITION . ':</td><td>' . getPositionSelect($position) . '</td></tr>';
    } else {
        echo '<tr valign="top"><td>' . _POSITION . ':</td><td><b>' . _RIGHT . '</b><input type="hidden" name="position" value="r" /></td></tr>';
    }
    echo '<tr valign="top"><td>' . _WEIGHT . ':</td><td><input type="text" name="weight" size="5" maxlength="3" value="' . $weight . '" /></td></tr>';
    if ($GLOBALS['multilingual']) {
        echo '<tr valign="top"><td>' . _LANGUAGE . ':</td><td>' . mxLanguageSelect('blanguage', $blanguage, 'language', true) . '</td></tr>';
    } else {
        echo '<input type="hidden" name="blanguage" value="" />';
    }
    echo '<tr valign="top"><td>' . _ACTIVATE2 . '</td><td>' . getActiveSelect($active) . '</td></tr>';
    echo '<tr valign="top"><td>' . _VIEWPRIV . '</td><td>' . getViewSelect($view) . '</td></tr>';
    echo '<tr valign="top"><td><!-- ' . _VIEWPRIV . ' --></td><td>' . getGroupSelect($bid) . '</td></tr>';
    switch ($type) {
        case _BLOCKFILE:
            echo '<tr valign="top">
            <td>' . _REFRESHTIME . ':</td>
            <td>' . getRefreshSelect($refresh, 1) . '<input type="hidden" name="b_content" value="' . $content . '" /></td>
        </tr>';
            break;
        case _RSSCONTENT:
            echo '<tr valign="top">
            <td>' . _REFRESHTIME . ':</td>
            <td>' . getRefreshSelect($refresh, 0) . '</td>
        </tr>';
            break;
    }
    echo '</table>';
    if ($menu) {
        echo '<input type="hidden" name="menu" value="1" />';
    }
    echo '<input type="hidden" name="op" value="BlocksEditSave" />'
     . '<input type="hidden" name="oldposition" value="' . $oldposition . '" />'
     . '<input type="hidden" name="bid" value="' . $bid . '" />'
     . '<input type="submit" value="' . _SAVEBLOCK . '" />'
     . '</form></fieldset>';
    CloseTable();
    echo '<br />';
    block_editmenue ($block, _BLOCKACTIVATION, $menu);
    showpreview($block);
    include('footer.php');
}

function Blocksave($block)
{
    global $prefix;

    $defaults = array(/* Standardwerte fr nicht gesetzte Feldwerte */
        'bid' => 0,
        'active' => 0,
        'weight' => 0,
        'view' => 0,
        'refresh' => 0,
        'url' => '',
        'blockfile' => '',
        'blanguage' => '',
        'b_content' => '',
        'title' => '',
        'position' => 0,
        'groups' => array(),
        'headline' => 0,

        );
    $block = array_merge($defaults, $block);
    $block['content'] = $block['b_content']; // Feld ist wegen #id umbenannt

    switch (true) {
        case $block['op'] == 'BlocksEditSave' && empty($block['menu']):
            $location = 'admin.php?op=BlocksEdit&bid=' . $block['bid'];
            break;
        case $block['op'] == 'BlocksEditSave':
            $location = 'admin.php?op=menu';
            break;
        default:
            $location = 'admin.php?op=BlocksAdmin';
    }

    if (!empty($block['headline'])) {
        $result = sql_query("SELECT sitename, headlinesurl FROM " . $prefix . "_headlines WHERE hid='" . $block['headline'] . "'");
        list ($xtitle, $block['url']) = sql_fetch_row($result);
        if (empty($block['title'])) $block['title'] = $xtitle;
    }

    if (!empty($block['url']) && empty($block['blockfile'])) {
        $block['content'] = mxGetRssContent($block['url']);
        // echo '<br /><br />' . _GOBACK . '</center>';
        switch (true) {
            case strpos($block['content'], _XMLERROROCCURED) === 0:
                rssfail($block['content']);
                exit;
            case empty($block['content']):
                rssfail(_RSSTRYAGAIN);
                exit;
        }
    }

    $block = mxAddSlashesForSQL($block);

    if ($block['op'] == 'BlocksEditSave') {
        $qry = "UPDATE ${prefix}_blocks SET
                        title='" . $block['title'] . "',
                        blockfile='" . $block['blockfile'] . "',
                        content='" . $block['content'] . "',
                        url='" . mx_urltohtml($block['url']) . "',
                        position='" . $block['position'] . "',
                        weight=" . $block['weight'] . ",
                        active=" . $block['active'] . ",
                        refresh=" . $block['refresh'] . ",
                        blanguage='" . $block['blanguage'] . "',
                        view=" . $block['view'] . "
                        WHERE bid=" . $block['bid'];
        if (!sql_query($qry)) {
            return mxRedirect($location, _ADMIN_SETTINGNOSAVED);
        }
        include_once(PMX_SYSTEM_DIR . DS . 'mx_reset.php');
        resetBlockCache($block['bid']);
    } else {
        $qry = "INSERT INTO ${prefix}_blocks
        (title, content, url, position, weight, active, refresh, time, blanguage, blockfile, view) VALUES
        ('" . $block['title'] . "','" . $block['content'] . "','" . $block['url'] . "','" . $block['position'] . "'," . $block['weight'] . "," . $block['active'] . "," . $block['refresh'] . ",0,'" . $block['blanguage'] . "','" . $block['blockfile'] . "'," . $block['view'] . ")";
        if (!sql_query($qry)) {
            return mxRedirect($location, _ADMIN_SETTINGNOSAVED);
        }
    }

    /* Reihenfolge korrigieren */
    repairweigth();

    /* Gruppen aktualisieren */
    $userconfig = load_class('Userconfig');
    sql_query("DELETE FROM " . $prefix . "_groups_blocks WHERE block_id=" . intval($block['bid']));
    if ($block['view'] == 1) {
        // Sicherstellen, dass wirklich eine Gruppe selektiert wurde
        if (empty($block['groups'])) {
            $block['groups'] = array(intval($userconfig->default_group));
        } elseif (!is_array($block['groups'])) {
            $block['groups'] = array(intval($block['groups']));
        }
        if (empty($block['groups'][0])) {
            $block['groups'] = array(intval($userconfig->default_group));
        }
        foreach ($block['groups'] as $groupid) {
            sql_query("INSERT INTO " . $prefix . "_groups_blocks (group_id, block_id) VALUES (" . intval($groupid) . ", " . intval($block['bid']) . ")");
        }
    }
    /* RSS-Daten an Headlines anfuegen */
    if (empty($block['headline']) && !empty($block['url']) && !empty($block['content']) && !empty($block['title'])) {
        $result2 = sql_query("SELECT headlinesurl FROM " . $prefix . "_headlines WHERE headlinesurl='" . $block['url'] . "' OR sitename='" . $block['title'] . "'");
        list ($xurl) = sql_fetch_row($result2);
        if (empty($xurl)) {
            sql_query("INSERT INTO " . $prefix . "_headlines (sitename, headlinesurl) VALUES ('" . $block['title'] . "', '" . $block['url'] . "')");
        }
    }

    mxRedirect($location, _ADMIN_SETTINGSAVED);
}

function getActiveSelect($active = 1)
{
    $active = (int)$active;
    $out = '<input type="radio" name="active" value="1"' . (($active == 1) ? ' checked="checked"' : '') . ' />' . _YES . ' &nbsp;&nbsp;';
    $out .= '<input type="radio" name="active" value="0"' . (($active == 0) ? ' checked="checked"' : '') . ' />' . _NO . "\n";
    return $out;
}

function getRefreshSelect($refresh = 0, $shownever = 0)
{
    $refresh = (int)$refresh;
    $out = '<select name="refresh">';
    if ($shownever) {
        $out .= '<option value="0"' . (($refresh == 0) ? ' selected="selected" class="current"' : '') . '>- ' . _NEVER . '</option>';
    }
    $out .= '<option value="300"' . (($refresh == 300) ? ' selected="selected" class="current"' : '') . '>5&nbsp;&nbsp; ' . _MINUTES . '</option>'
     . '<option value="600"' . (($refresh == 600) ? ' selected="selected" class="current"' : '') . '>10 ' . _MINUTES . '</option>'
     . '<option value="1200"' . (($refresh == 1200) ? ' selected="selected" class="current"' : '') . '>20 ' . _MINUTES . '</option>'
     . '<option value="1800"' . (($refresh == 1800) ? ' selected="selected" class="current"' : '') . '>30 ' . _MINUTES . '</option>'
     . '<option value="3600"' . (($refresh == 3600) ? ' selected="selected" class="current"' : '') . '>1&nbsp;&nbsp; ' . _HOUR . '</option>'
     . '<option value="18000"' . (($refresh == 18000) ? ' selected="selected" class="current"' : '') . '>5&nbsp;&nbsp; ' . _HOURS . '</option>'
     . '<option value="36000"' . (($refresh == 36000) ? ' selected="selected" class="current"' : '') . '>10&nbsp; ' . _HOURS . '</option>'
     . '<option value="86400"' . (($refresh == 86400) ? ' selected="selected" class="current"' : '') . '>24&nbsp; ' . _HOURS . '</option>'
     . '<option value="172800"' . (($refresh == 172800) ? ' selected="selected" class="current"' : '') . '>48&nbsp; ' . _HOURS . '</option>'
     . '</select>';
    if ($shownever) {
        $out .= '<br /><span class="note tiny">' . _BLOCKCACHEMSG . '</span>';
    }
    // ."&nbsp;<font class=\"tiny\">"._ONLYHEADLINES."</font>";
    return $out;
}

function getRefreshTimeString($refresh)
{
    switch (intval($refresh)) {
        case 300 :
            return '5 ' . _MINUTES;
        case 600 :
            return '10 ' . _MINUTES;
        case 1200 :
            return '20 ' . _MINUTES;
        case 1800 :
            return '30 ' . _MINUTES;
        case 3600 :
            return '1 ' . _HOUR;
        case 18000 :
            return '5 ' . _HOURS;
        case 36000 :
            return '10 ' . _HOURS;
        case 86400 :
            return '24 ' . _HOURS;
        case 172800 :
            return '48 ' . _HOURS;
        default :
            return '';
    }
}

function getViewSelect($view = 0)
{
    $view = (int)$view;
    $out = '<select name="view">'
     . '<option value="0"' . (($view == 0) ? ' selected="selected" class="current"' : '') . '>' . _MVALL . '</option>'
     . '<option value="1"' . (($view == 1) ? ' selected="selected" class="current"' : '') . '>' . _MVGROUPS . '</option>'
     . '<option value="2"' . (($view == 2) ? ' selected="selected" class="current"' : '') . '>' . _MVADMIN . '</option>'
     . '<option value="4"' . (($view == 4) ? ' selected="selected" class="current"' : '') . '>' . _MVSYSADMIN . '</option>'
     . '<option value="3"' . (($view == 3) ? ' selected="selected" class="current"' : '') . '>' . _MVANON . '</option>'
     . '</select>';
    return $out;
}

function getGroupSelect($blockid = 0)
{
    global $prefix;

    $userconfig = load_class('Userconfig');

    $blockid = (int)$blockid;
    if (!empty($blockid)) {
        $qry = "SELECT group_id FROM ${prefix}_groups_blocks WHERE block_id=" . $blockid;
        $result = sql_query($qry);
        while (list($group_id) = sql_fetch_row($result)) {
            $groups[] = $group_id;
        }
    }
    $groups = (empty($groups)) ? $userconfig->default_group : $groups;
    $groupoptions = getAllAccessLevelSelectOptions($groups);
    $cnt = substr_count($groupoptions, '<option') + 1;
    $out = '<select name="groups[]" size="' . $cnt . '" multiple="multiple">' . $groupoptions . '</select>';
    return $out;
}

function getPositionSelect($pos = '')
{
    $out = '<select name="position">'
     . '<option value="l"' . (($pos == 'l') ? ' selected="selected" class="current"' : '') . '>' . _LEFT . '</option>'
     . '<option value="c"' . (($pos == 'c') ? ' selected="selected" class="current"' : '') . '>' . _CENTERUP . '</option>'
     . '<option value="d"' . (($pos == 'd') ? ' selected="selected" class="current"' : '') . '>' . _CENTERDOWN . '</option>'
     . '<option value="r"' . (($pos == 'r') ? ' selected="selected" class="current"' : '') . '>' . _RIGHT . '</option>'
     . '</select>';
    return $out;
}

function getHeadlineSelect ($url = '')
{
    global $prefix;
    /* zur Sicherheit, die Entities richtigstellen */
    $url = mx_urltohtml($url);
    $res = sql_query("SELECT hid, sitename, headlinesurl FROM " . $prefix . "_headlines ORDER BY sitename");
    $out = '<input type="text" name="url" size="30" maxlength="200" value="' . $url . '" />&nbsp;&nbsp;';
    $out .= '<select name="headline">';
    $out .= '<option value="0" selected="selected">' . _CUSTOM . '</option>';
    while (list($hid, $htitle, $hurl) = sql_fetch_row($res)) {
        $out .= '<option value="' . $hid . '"' . (($url == $hurl) ? ' selected="selected" class="current"' : '') . '>' . $htitle . '</option>';
    }
    $out .= '</select>&nbsp;[&nbsp;<a href="admin.php?op=HeadlinesAdmin">' . _SETUP_HEADLINES . '</a>&nbsp;]<br />';
    $out .= '<span class="note tiny">' . _SETUPHEADLINES . '</span>';
    return $out;
}

function block_editmenue($block, $optitle = '', $menu = 0)
{
    $menu = (empty($menu)) ? 0 : 1;
    $optitle = (empty($optitle)) ? _BLOCKSADMIN : $optitle;
    $active = ($block['active']) ?_DEACTIVATE : _ACTIVATE;

    switch ($menu) {
        case 1:
            $link[] = '<a href="admin.php?op=ChangeStatus&amp;bid=' . $block['bid'] . '&amp;menu=1">' . $active . '</a>';
            $link[] = '<a href="admin.php?op=BlocksEdit&amp;bid=' . $block['bid'] . '&amp;menu=1">' . _EDIT . '</a>';

            if (!mxIsNewsBlockfile($block['blockfile'])) {
                $link[] = '<a href="admin.php?op=BlocksDelete&amp;bid=' . $block['bid'] . '&amp;menu=1">' . _DELETE . '</a>';
            } else {
                $link[] = _DELETE;
            }
            break;

        default:
            $link[] = '<a href="admin.php?op=ChangeStatus&amp;bid=' . $block['bid'] . '">' . $active . '</a>';
            $link[] = '<a href="admin.php?op=BlocksEdit&amp;bid=' . $block['bid'] . '">' . _EDIT . '</a>';

            if (!mxIsNewsBlockfile($block['blockfile'])) {
                $link[] = '<a href="admin.php?op=BlocksDelete&amp;bid=' . $block['bid'] . '">' . _DELETE . '</a>';
            } else {
                $link[] = _DELETE;
            }
            break;
    }

    $link[] = '<a href="admin.php?op=BlocksAdmin">' . _BLOCKSADMIN . '</a>';
    $links = implode(' | ', $link);
    OpenTable();
    echo '<center><span class="option"><b>' . _BLOCKSADMIN . ': ' . _FUNCTIONS . '</b></span><br /><br />';
    echo '[ ' . $links . ' ]</center>';
    CloseTable();
    echo '<br />';
}

function block_show()
{
    global $prefix;
    $bid = (int)$_GET['bid'];
    $result = sql_query("SELECT * FROM ${prefix}_blocks WHERE bid=" . $bid);
    $block = sql_fetch_array($result);
    include('header.php');
    // GraphicAdmin();
    title(_BLOCKSADMIN);
    block_editmenue($block);
    showpreview($block);
    include('footer.php');
}

function showpreview($block)
{
    // mxDebugFuncVars($block);
    global $prefix;
    if (mxIsNewsBlockfile($block['blockfile'])) {
        $result = sql_query("SELECT * FROM ${prefix}_stories LIMIT 0,1");
        $GLOBALS['story_blocks'] = sql_fetch_array($result);
        $GLOBALS['name'] = 'News';
        @mxGetLangfile('News');
    }
    OpenTable();
    $block = mxGetBlockData($block, 1); // ohne cache
    echo '<p>' . _BLOCKPREVIEW . ' &quot;<b>' . $block['title'] . '</b>&quot;:</p><br />';
    render_blocks($block);
    CloseTable();
    echo '<br />';
}

function fixweight()
{
    repairweigth();
    mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
    exit;
}

function repairweigth()
{
    global $prefix;
    $newweight = 0;
    $lastpos = 'xyz';
    $qry = "SELECT position, bid, weight
            FROM ${prefix}_blocks
            ORDER BY position, weight, bid";
    $result = sql_query($qry);
    while (list($pos, $bid, $weight) = sql_fetch_row($result)) {
        if ($lastpos != $pos) {
            $lastpos = $pos;
            $newweight = 0;
        }
        $newweight++;
        if ($newweight != $weight) {
            $qry = "UPDATE ${prefix}_blocks SET weight = $newweight WHERE bid = $bid";
            sql_query($qry);
        }
    }
}

function BlockOrder ()
{
    global $prefix;
    extract($_GET);
    $result = sql_query("UPDATE ${prefix}_blocks SET weight = " . intval($weight) . " WHERE bid = " . intval($bidrep));
    $result2 = sql_query("UPDATE ${prefix}_blocks SET weight = " . intval($weightrep) . " WHERE bid = " . intval($bidori));
    mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
}

function rssfail($message = '')
{
    include('header.php');
    GraphicAdmin();
    title(_BLOCKSADMIN);
    OpenTable();
    echo '<center><b>' . _RSSFAIL . '</b><br /><br />' . $message . '<br /><br />' . _GOBACK . '</center>';
    CloseTable();
    include('footer.php');
    die;
}

function ChangeStatus()
{
    global $prefix;
    $ok = (empty($_GET['ok'])) ? 0 : 1;
    $bid = (int)$_GET['bid'];
    $menu = (empty($_GET['menu'])) ? 0 : 1;
    $result = sql_query("SELECT * FROM ${prefix}_blocks WHERE bid = $bid");
    $block = sql_fetch_array($result);
    extract ($block);
    if (($ok) OR ($block['active'] == 1)) {
        $active = (empty($block['active'])) ? 1 : 0;
        $result = sql_query("UPDATE ${prefix}_blocks SET active = '$active' WHERE bid = $bid");
        switch ($menu) {
            case 1:
                mxRedirect('admin.php?op=menu', _ADMIN_SETTINGSAVED);
                break;

            default:
                mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
                break;
        }
    } else {
        include('header.php');
        GraphicAdmin();
        title(_BLOCKACTIVATION);
        OpenTable2();
        echo '<center><br />' . _WANT2ACTIVATE . '<br /><br />';
        switch ($menu) {
            case 1:
                echo '[&nbsp;<a href="admin.php?op=menu">' . _NO . '</a> | <a href="admin.php?op=ChangeStatus&amp;bid=' . $bid . '&amp;ok=1&amp;menu=1">' . _YES . '</a>&nbsp;]<br />';
                break;

            default:
                echo '[&nbsp;<a href="admin.php?op=BlocksAdmin">' . _NO . '</a> | <a href="admin.php?op=ChangeStatus&amp;bid=' . $bid . '&amp;ok=1">' . _YES . '</a>&nbsp;]<br />';
                break;
        }
        echo '</center>';
        CloseTable2();
        echo '<br />';
        showpreview($block);
        block_editmenue ($block, _BLOCKACTIVATION, $menu);
        include('footer.php');
    }
}

function BlocksDelete()
{
    global $prefix;
    $ok = (empty($_GET['ok'])) ? 0 : 1;
    $bid = (int)$_GET['bid'];
    $menu = (empty($_GET['menu'])) ? 0 : 1;
    if ($ok) {
        sql_query("DELETE FROM ${prefix}_blocks WHERE bid = $bid");
        repairweigth();
        switch ($menu) {
            case 1:
                mxRedirect('admin.php?op=menu', _ADMIN_SETTINGSAVED);
                break;

            default:
                mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
                break;
        }
    }
    $result = sql_query("SELECT * FROM ${prefix}_blocks WHERE bid = $bid");
    $block = sql_fetch_array($result);
    extract ($block);
    include('header.php');
    GraphicAdmin();
    title(_BLOCKSADMIN);
    OpenTableAl();
    echo '<center>' . _ARESUREDELBLOCK . ' <i>' . $title . '</i>?';
    switch ($menu) {
        case 1:
            echo '<br /><br />[&nbsp;<a href="admin.php?op=menu">' . _NO . '</a> | <a href="admin.php?op=BlocksDelete&amp;bid=' . $bid . '&amp;ok=1&amp;menu=1">' . _YES . '</a>&nbsp;]</center>';
            break;

        default:
            echo '<br /><br />[&nbsp;<a href="admin.php?op=BlocksAdmin">' . _NO . '</a> | <a href="admin.php?op=BlocksDelete&amp;bid=' . $bid . '&amp;ok=1">' . _YES . '</a>&nbsp;]</center>';
            break;
    }
    CloseTableAl();
    echo '<br />';
    showpreview($block);
    block_editmenue ($block, _BLOCKACTIVATION, $menu);
    include('footer.php');
}

function HeadlinesAdmin()
{
    global $prefix;
    include('header.php');
    GraphicAdmin();
    title(_HEADLINESADMIN);
    OpenTable();
    echo '<form action="admin.php" method="post">'
     . '<table class="list">'
     . '<tr valign="top"><th>' . _SITENAME . '</th><th>' . _URL . '</th><th>' . _FUNCTIONS . '</th></tr>';
    $result = sql_query("SELECT hid, sitename, headlinesurl FROM " . $prefix . "_headlines ORDER BY sitename");
    while (list($hid, $sitename, $headlinesurl) = sql_fetch_row($result)) {
        $headlinesurl = mx_urltohtml($headlinesurl);
        echo '<tr><td>' . $sitename . '</td>'
         . '<td class="tiny"><a href="' . $headlinesurl . '" target="_blank">' . $headlinesurl . '</a></td>'
         . '<td class="nowrap">[&nbsp;<a href="admin.php?op=HeadlinesEdit&amp;hid=' . $hid . '">' . _EDIT . '</a> | <a href="admin.php?op=HeadlinesDel&amp;hid=' . $hid . '&amp;ok=0">' . _DELETE . '</a>&nbsp;]</td></tr>';
    }
    echo '</table></form>';
    CloseTable();
    echo '<br />';
    OpenTable();
    echo '<span class="option"><b>' . _ADDHEADLINE . '</b></span><br /><br />'
     . '<form action="admin.php" method="post">'
     . '<table class="full">'
     . '<tr valign="top"><td>' . _SITENAME . ':</td><td><input type="text" name="xsitename" size="31" maxlength="30" /></td></tr>'
     . '<tr valign="top"><td>' . _RSSFILE . ':</td><td><input type="text" name="headlinesurl" size="50" maxlength="200" /></td></tr>'
     . '</table>'
     . '<input type="hidden" name="op" value="HeadlinesAdd" />'
     . '<input type="submit" value="' . _ADD . '" />'
     . '</form>';
    CloseTable();
    include('footer.php');
}

function HeadlinesEdit()
{
    global $prefix;
    $hid = intval($_GET['hid']);
    $result = sql_query("SELECT sitename, headlinesurl FROM " . $prefix . "_headlines WHERE hid=" . $hid);
    list($xsitename, $headlinesurl) = sql_fetch_row($result);
    include('header.php');
    GraphicAdmin();
    title(_HEADLINESADMIN);
    OpenTable();
    echo '<p class="option" align="center"><b>' . _EDITHEADLINE . '</b></p>
    <form action="admin.php" method="post">
    <table class="full">
    <tr valign="top"><td>' . _SITENAME . ':</td><td><input type="text" name="xsitename" size="31" maxlength="30" value="' . mxEntityQuotes($xsitename) . '" /></td></tr>
    <tr valign="top"><td>' . _RSSFILE . ':</td><td><input type="text" name="headlinesurl" size="50" maxlength="200" value="' . mxEntityQuotes($headlinesurl) . '" /></td></tr>
    </table>
    <input type="hidden" name="hid" value="' . $hid . '" />
    <input type="hidden" name="op" value="HeadlinesSave" />
    <input type="submit" value="' . _SAVECHANGES . '" />
    </form>';
    CloseTable();
    include('footer.php');
}

function HeadlinesSave($pvs)
{
    global $prefix;
    $hid = $pvs['hid'];
    // $xsitename = str_replace(" ", "", $xsitename);
    sql_query("UPDATE " . $prefix . "_headlines SET sitename='" . mxAddSlashesForSQL($pvs['xsitename']) . "', headlinesurl='" . mxAddSlashesForSQL(mx_urltohtml($pvs['headlinesurl'])) . "' WHERE hid='" . $hid . "'");
    mxRedirect('admin.php?op=HeadlinesAdmin', _ADMIN_SETTINGSAVED);
}

function HeadlinesAdd($pvs)
{
    global $prefix;
    sql_query("INSERT INTO " . $prefix . "_headlines (sitename, headlinesurl) VALUES ('" . mxAddSlashesForSQL($pvs['xsitename']) . "', '" . mxAddSlashesForSQL($pvs['headlinesurl']) . "')");
    mxRedirect('admin.php?op=HeadlinesAdmin', _ADMIN_SETTINGSAVED);
}

function HeadlinesDel()
{
    global $prefix;
    $ok = (empty($_GET['ok'])) ? 0 : 1;
    $hid = (empty($_GET['hid'])) ? 0 : intval($_GET['hid']);
    if ($ok) {
        sql_query("DELETE FROM " . $prefix . "_headlines WHERE hid=" . $hid);
        mxRedirect('admin.php?op=HeadlinesAdmin', _ADMIN_SETTINGSAVED);
    } else {
        include('header.php');
        GraphicAdmin();
        title(_HEADLINESADMIN);
        OpenTable();
        echo '<p class="bigger stronger align-center">' . _SURE2DELHEADLINE . '</p>';
        echo '<p class="align-center">[&nbsp;<a href="admin.php?op=HeadlinesDel&amp;hid=' . $hid . '&amp;ok=1">' . _YES . '</a> | <a href="admin.php?op=HeadlinesAdmin">' . _NO . '</a>&nbsp;]</p>';
        CloseTable();
        include('footer.php');
    }
}

function mxGetBlockfileSelect($blockfile = '')
{
    global $prefix;
    $dbblocks = array();
    $result = sql_query("SELECT blockfile FROM ${prefix}_blocks WHERE blockfile<>''");
    while (list($bfs) = sql_fetch_row($result)) {
        $dbblocks[] = $bfs;
    }

    $handle = opendir('blocks');
    while (false !== ($block = readdir($handle))) {
        if (preg_match('#^block-(.+)\.php$#', $block, $matches)) {
            $bl = $matches[1];
            $mode = (in_array($block, $dbblocks)) ? 1 : 0;
            $is = ($mode) ? '* ': '';
            if (!mxIsNewsBlockfile($block)) {
                $options[$mode][strtolower($bl)] = ($blockfile == $block) ? '<option value="' . $block . '" selected="selected">' . $is . $bl . '</option>' : '<option value="' . $block . '">' . $is . $bl . '</option>';
            } else {
                /* Falls ein neuer News-Block gefunden wurde, diesen automatisch in die Tabelle einfuegen */
                if (!$mode) {
                    $caption = str_replace(MX_NEWSBLOCK_PREFIX, '', 'block-' . $bl);
                    $qry = "INSERT INTO `${prefix}_blocks` (`bid`, `bkey`, `title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES (NULL, '', '" . $caption . "', NULL, '', 'r', 0, 0, 0, 0, '', '" . $block . "', 0);";
                    sql_query($qry);
                }
            }
        }
    }
    closedir($handle);
    if (empty($blockfile)) {
        $options[0][' '] = '<option value="" selected="selected">&nbsp;</option>';
    }
    $view = '';
    if (isset($options[0])) {
        ksort($options[0]);
        $view .= implode("\n", $options[0]);
    }
    if (isset($options[0]) && isset($options[1])) {
        $view .= '<option value="">____________________________________</option>' . "\n";
    }
    if (isset($options[1])) {
        ksort($options[1]);
        $view .= implode("\n", $options[1]);
    }
    $out = '<select name="blockfile">' . $view . '</select>' . "\n";
    $out .= '<br /><span class="important tiny">' . _BLOCKINSYSTEM . '</span>';
    // $out .= "&nbsp;&nbsp;<font class=\"tiny\">"._FILEINCLUDE."</font>";
    return $out;
}

switch ($op) {
    case 'BlocksAdmin':
        BlocksAdmin();
        break;

    case 'BlocksAdd':
        Blocksave($_POST);
        break;

    case 'BlocksEdit':
        BlocksEdit();
        break;

    case 'BlocksEditSave':
        Blocksave($_POST);
        break;

    case 'ChangeStatus':
        ChangeStatus();
        break;

    case 'BlocksDelete':
        BlocksDelete();
        break;

    case 'BlockOrder':
        BlockOrder ();
        break;

    case 'HeadlinesDel':
        HeadlinesDel();
        break;

    case 'HeadlinesAdd':
        HeadlinesAdd($_POST);
        break;

    case 'HeadlinesSave':
        HeadlinesSave($_POST);
        break;

    case 'HeadlinesAdmin':
        HeadlinesAdmin();
        break;

    case 'HeadlinesEdit':
        HeadlinesEdit();
        break;

    case 'fixweight':
        fixweight();
        break;

    case 'block_show':
        block_show();
        break;

    case 'BlocksListWeigth':
        BlocksListWeigth($_POST);
        break;
}

?>